package net.stepniak.api.picheese.controller;

import net.stepniak.api.error.exception.ServerResponseException;
import net.stepniak.api.picheese.logic.KeyLogic;
import net.stepniak.api.picheese.repository.KeyDAO;
import net.stepniak.api.picheese.services.PicheeseBaseService;
import net.stepniak.picheese.error.server.ServerErrorType;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.ws.rs.*;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.UriBuilder;
import java.security.NoSuchAlgorithmException;

@Path("keys")
//@Produces(MediaType.APPLICATION_JSON + "; charset=utf-8")
@Produces(MediaType.APPLICATION_JSON)
@Service
public class KeyController extends PicheeseBaseService<KeyLogic> {
  static Logger logger = LoggerFactory.getLogger(KeyController.class);

  public KeyController() {
    logger.info("KeyController constructor()");
  }

  public KeyDAO getKeyDAO() {
    return (KeyDAO) getDao();
  }

  @Autowired
  public void setKeyDAO(KeyDAO dao) {
    setDao(dao);
  }

  @POST
  public Response create() {
    logger.info("KeyController save()");

//    throw new NotAuthorizedResponseException(uriInfo);  //TODO secure

    KeyLogic keyLogic = null;

    try {
      keyLogic = KeyLogic.generateNewKey();
    } catch (NoSuchAlgorithmException e) {
      throw new ServerResponseException(uriInfo, ServerErrorType.INTERNAL_EXCEPTION, e);
    }

    getKeyDAO().save(keyLogic);

    return Response
      .status(Response.Status.CREATED)
      .entity(getJsonStringFromEntity(keyLogic.getPojos()))
      .expires(keyLogic.getExpiration())
      .location(UriBuilder.fromPath("/" + keyLogic.getId()).build())
      .build();
  }

  @GET
  @Path("/{id}")
  public Response retrieve(@PathParam("id") String id) {
//TODO role
//    if (sc.isUserInRole("admin")) {
    return super.retrieve(id, uriInfo);
//    }
//
//    throw new NotAuthorizedResponseException(uriInfo);
  }

}
