package net.stepniak.api.picheese.entities;

import net.stepniak.api.entities.BaseEntity;
import net.stepniak.picheese.PicheeseConst;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

import javax.persistence.*;

@MappedSuperclass
@Inheritance(strategy = InheritanceType.TABLE_PER_CLASS)
public abstract class UserEntity extends BaseEntity<String> {
  @Id
  @Column(columnDefinition = "char(" + PicheeseConst.USER_ID_LENGHT + ")", unique = true, nullable = false, insertable = true, length = PicheeseConst.USER_ID_LENGHT)
  @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "UserIdGenerator")
  @GenericGenerator(name = "UserIdGenerator",
    strategy = "net.stepniak.api.picheese.persistance.UserIdGenerator",
    parameters = {
      @Parameter(name = "sequence", value = "user_id_sequence")
    })
  private String id;

  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }
}
