package net.stepniak.api.picheese.logic;

import net.stepniak.api.entities.SimpleEntity;
import net.stepniak.api.image.ImageContent;
import net.stepniak.picheese.PicheeseConst;
import net.stepniak.picheese.error.server.exception.ImageException;
import net.stepniak.picheese.pojos.v1.PhotoUrl;
import org.apache.commons.lang.NotImplementedException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

@Entity
@Table(name = "image")
public class ImageLogic extends SimpleEntity {
  static Logger logger = LoggerFactory.getLogger(ImageLogic.class);

  private byte[] thumbnail;
  private byte[] normal;
  private byte[] original;

  @Column(nullable = false, length = 10)
  private String mimeType;

  public ImageLogic() {
  }

  public String getMimeType() {
    if (this.mimeType == null) {
      this.mimeType = PicheeseConst.IMAGE_DEFAULT_MIME_TYPE;
    }

    return mimeType;
  }

  public byte[] getThumbnail() {
    return thumbnail;
  }

  public byte[] getNormal() {
    return normal;
  }

  public byte[] getOriginal() {
    return original;
  }

  public void upload(ImageContent imageContent) throws ImageException {
    this.mimeType = imageContent.getMimeType();

    //set data
    this.original = imageContent.getOriginal();
    this.thumbnail = imageContent.getThumbnail();
    this.normal = imageContent.getNormal();
  }

  @Override
  public PhotoUrl getPojos() {
    throw new NotImplementedException();
  }

  @Override
  public void onCreate() {
  }
}
