package net.stepniak.api.picheese.logic;

import net.stepniak.api.picheese.entities.KeyEntity;
import net.stepniak.picheese.PicheeseConst;
import net.stepniak.picheese.pojos.v1.Key;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.persistence.Entity;
import javax.persistence.Table;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Date;


@Entity
@Table(name = "key")
public class KeyLogic extends KeyEntity {

  static Logger logger = LoggerFactory.getLogger(KeyLogic.class);

  private Date expire;

  public static KeyLogic generateNewKey() throws NoSuchAlgorithmException {
    KeyLogic key = new KeyLogic();
    key.generateKey();
    return key;
  }

  public KeyLogic() {
    this.expire = calculateExpiration();
  }

  public Date getExpiration() {
    return expire;
  }

  @Override
  public void setCreationDate(Date creationDate) {
    super.setCreationDate(creationDate);
    this.expire = calculateExpiration();
  }

  @Override
  public Key getPojos() {
    return new Key(getId(), getCreationDate(), getExpiration());
  }

  @Override
  public void onCreate() {
  }

  private void generateKey() throws NoSuchAlgorithmException {
    logger.info("KeyLogic.generateKey()");

    String keySalt = "key" + Math.random() + "logic"; // TODO from config

    MessageDigest mDigest = MessageDigest.getInstance("SHA1");
    byte[] result = mDigest.digest(keySalt.getBytes());
    StringBuffer sb = new StringBuffer();

    for (int i = 0; i < result.length; i++) {
      sb.append(Integer.toString((result[i] & 0xff) + 0x100, 16).substring(1));
    }

    String newKeyId = sb.substring(4, 4 + PicheeseConst.KEY_LENGHT);

    this.expire = calculateExpiration();
    logger.info("KeyLogic.generateKey(\"{}\")", newKeyId);

    this.setId(newKeyId);
  }

  private Date calculateExpiration() {

    long created = 0L;

    if (getCreationDate() == null) {
      created = System.currentTimeMillis();
    } else {
      created = getCreationDate().getTime();
    }

    return new Date(created + PicheeseConst.KEY_EXPIRATION_TIME);
  }
}
