package net.stepniak.api.picheese.logic;

import javax.persistence.*;
import java.io.Serializable;

@Entity
@Table(name = "photos_rating")
public class PhotoRateLogic {
  @EmbeddedId()
  private Key key;

  public PhotoRateLogic() {
  }

  public PhotoRateLogic(UserLogic userLogic, PhotoLogic photoLogic) {
    key = new Key(userLogic, photoLogic);
  }

  @Embeddable
  public static class Key implements Serializable {
    @ManyToOne
    private UserLogic userLogic;

    @ManyToOne
    private PhotoLogic photoLogic;

    public Key() {
    }

    public Key(UserLogic userLogic, PhotoLogic photoLogic) {
      this.userLogic = userLogic;
      this.photoLogic = photoLogic;
    }
  }
}
