package net.stepniak.api.picheese.logic;

import net.stepniak.api.picheese.entities.UserEntity;
import net.stepniak.picheese.PicheeseConst;
import net.stepniak.picheese.pojos.v1.User;
import net.stepniak.picheese.user.AccountType;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

@Entity
@Table(name = "users")
public class UserLogic extends UserEntity {
  @Column(nullable = false, length = PicheeseConst.USER_NAME_LENGHT)
  public String userName;

  @Column(nullable = true, length = PicheeseConst.USER_EMAIL_LENGHT)
  public String email;

  public char accountType;

  public UserLogic() {
  }

  public UserLogic(String userName, String email, AccountType accountType) {
    this.userName = userName;
    this.email = email;
    this.accountType = accountType.getCode();
  }

  public String getName() {
    return userName;
  }

  public String getEmail() {
    return email;
  }

  public char getAccountType() {
    return accountType;
  }

  @Override
  public User getPojos() {
    return new User(getId(), getName());
  }

  @Override
  public void onCreate() {
  }

  public static UserLogic createUser(String userName, String email) {
    return new UserLogic(userName, email, AccountType.PICHEESE);
  }
}
