package net.stepniak.api.picheese.persistance;

import net.stepniak.api.picheese.logic.UserLogic;
import net.stepniak.picheese.PicheeseConst;
import org.hibernate.MappingException;
import org.hibernate.dialect.Dialect;
import org.hibernate.engine.spi.SessionImplementor;
import org.hibernate.id.SequenceGenerator;
import org.hibernate.type.LongType;
import org.hibernate.type.Type;

import java.io.Serializable;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Properties;

public class UserIdGenerator extends SequenceGenerator {

  @Override
  public void configure(Type type, Properties params, Dialect dialect) throws MappingException {
    super.configure(LongType.INSTANCE, params, dialect);  //generate as long
  }

  @Override
  public Serializable generate(SessionImplementor session, Object obj) {
    UserLogic userLogic = (UserLogic) obj;
    Object sequenceResult = super.generate(session, obj);

    if (sequenceResult == null) {
      return null;
    }

    try {
      String salt = sequenceResult.toString() + Math.random();

      MessageDigest mDigest = MessageDigest.getInstance("SHA-256");
      byte[] result = mDigest.digest(salt.getBytes());
      StringBuffer sb = new StringBuffer();

      for (int i = 0; i < result.length; i++) {
        sb.append(Integer.toString((result[i] & 0xff) + 0x100, 16).substring(1));
      }

      String userId = sb.substring(0, PicheeseConst.USER_ID_LENGHT - 1);

      return String.format("%s%s", userLogic.getAccountType(), userId);
    } catch (NoSuchAlgorithmException e) {
      //TODO
    }

    return null;
  }
}

