package net.stepniak.api.picheese.repository;

import net.stepniak.api.entities.SearchResults;
import net.stepniak.api.persistence.JpaDao;
import net.stepniak.api.picheese.logic.PhotoLogic;
import org.springframework.stereotype.Repository;

import java.util.List;


@Repository
public class PhotoDAO extends JpaDao<PhotoLogic> {

  public PhotoDAO() {
    super(PhotoLogic.class);
  }

  public SearchResults<PhotoLogic> retrieveByLatest(final int pageNumber, final int pageLimit) {
    List<PhotoLogic> entities = retrieve(pageNumber, pageLimit, "entity.creationDate DESC");
    return new SearchResults(entities, count());
  }

  public SearchResults<PhotoLogic> retrieveLucky(final int pageNumber, final int pageLimit) {
    List<PhotoLogic> entities = retrieve(pageNumber, pageLimit, "RANDOM()");
    return new SearchResults(entities, count());
  }

  public SearchResults<PhotoLogic> retrieveTop(final int pageNumber, final int pageLimit) {
    List<PhotoLogic> entities = retrieve(pageNumber, pageLimit, "entity.score DESC");
    return new SearchResults(entities, count());
  }
}
