package net.stepniak.api.picheese.repository;

import net.stepniak.api.persistence.JpaDao;
import net.stepniak.api.picheese.logic.UserLogic;
import net.stepniak.picheese.user.AccountType;
import org.springframework.stereotype.Repository;

import javax.persistence.NoResultException;
import javax.persistence.Query;


@Repository
public class UserDAO extends JpaDao<UserLogic> {

  public UserDAO() {
    super(UserLogic.class);
  }

  public UserLogic retrieveByEmailAndName(final String email, final String userName, final AccountType accountType) {
    Query jpaQuery = getEntityManager().createQuery(
      "from " + getManagedClass().getSimpleName() + " entity " +
        "where " +
        "entity.active = true AND " +
        "entity.email = :email AND " +
        "entity.userName = :userName AND " +
        "entity.accountType = :accountType"
    )
    .setMaxResults(1);

    jpaQuery.setParameter("email", email);
    jpaQuery.setParameter("userName", userName);
    jpaQuery.setParameter("accountType", accountType.getCode());

    try {
      Object user = jpaQuery.getSingleResult();
      return (UserLogic) user;
    }
    catch (NoResultException ex) {
    }

    return null;
  }

}
