package net.stepniak.api.picheese.validator;

import net.stepniak.api.picheese.logic.KeyLogic;
import net.stepniak.api.picheese.repository.KeyDAO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;

@Component
public class KeyValidator {
  @Autowired
  private KeyDAO dao;

  public boolean isValid(String key) {
    KeyLogic keyLogic = dao.retrieve(key);
    return (keyLogic != null && keyLogic.getExpiration().getTime() >= new Date().getTime());
  }
}
