package net.stepniak.api.picheese.validator;

import net.stepniak.api.error.exception.ServerResponseException;
import net.stepniak.picheese.error.server.ServerErrorType;

import javax.ws.rs.core.UriInfo;

public class PagingValidator {

  public static void validatePageNumber(int page, UriInfo uriInfo) {
    if (page < 1) {
      throw new ServerResponseException(uriInfo, ServerErrorType.PARAM_PAGE_NUMBER);
    }
  }

  public static void validatePageLimit(int limit, UriInfo uriInfo) {
    if (limit < 1) {
      throw new ServerResponseException(uriInfo, ServerErrorType.PARAM_PAGE_LIMIT);
    }
  }
}
