package net.stepniak.api.picheese.validator;

import net.stepniak.api.error.exception.ServerResponseException;
import net.stepniak.picheese.PicheeseConst;
import net.stepniak.picheese.error.server.ServerErrorType;

import javax.ws.rs.core.UriInfo;

public class PhotosValidator {

  public static void validateDescription(String description, UriInfo uriInfo) {
    if (description == null || description.length() < 1) {
      throw new ServerResponseException(uriInfo, ServerErrorType.PARAM_DESCRIPTION);
    }

    if (description.length() > PicheeseConst.PHOTOS_DESCRIPTION_LENGHT) {
      throw new ServerResponseException(uriInfo, ServerErrorType.PARAM_DESCRIPTION_LENGTH);
    }
  }

  public static void validateTitle(String title, UriInfo uriInfo) {
    if (title == null || title.length() < 1) {
      throw new ServerResponseException(uriInfo, ServerErrorType.PARAM_TITLE);
    }

    if (title.length() > PicheeseConst.PHOTOS_TITLE_LENGHT) {
      throw new ServerResponseException(uriInfo, ServerErrorType.PARAM_TITLE_LENGTH);
    }
  }

  public static void validateRate(int rate, UriInfo uriInfo) {
    if (rate != -1 && rate != 1) {
      throw new ServerResponseException(uriInfo, ServerErrorType.PARAM_RATE);
    }
  }

}
