package net.stepniak.api.picheese.validator;

import net.stepniak.api.picheese.logic.SessionLogic;
import net.stepniak.api.picheese.logic.UserLogic;
import net.stepniak.api.picheese.repository.SessionDAO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;

@Component
public class SessionValidator {
  @Autowired
  private SessionDAO dao;

  public boolean isValid(String sessionId) {
    SessionLogic sessionLogic = dao.retrieve(sessionId);
    return (sessionLogic != null && sessionLogic.getExpiration().getTime() >= new Date().getTime());
  }

  public UserLogic getUserLogic(String sessionId) {
    SessionLogic sessionLogic = dao.retrieve(sessionId);

    if (sessionLogic != null) {
       return sessionLogic.getUserLogic();
    }

    return new UserLogic();
  }
}
