package net.stepniak.api.picheese.validator;

import net.stepniak.api.error.exception.ServerResponseException;
import net.stepniak.picheese.PicheeseConst;
import net.stepniak.picheese.error.server.ServerErrorType;

import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;
import javax.ws.rs.core.UriInfo;

public class UserValidator {

  public static void validateEmail(String email, UriInfo uriInfo) {

    if (email != null && email.length() > 0) {

      if (email.length() > PicheeseConst.USER_EMAIL_LENGHT) {
        throw new ServerResponseException(uriInfo, ServerErrorType.PARAM_USER_NAME_LENGTH);
      }

      try {
        InternetAddress emailAddr = new InternetAddress(email);
        emailAddr.validate();

        //TODO check duplicate
        return;
      } catch (AddressException ex) {
      }
    }

    throw new ServerResponseException(uriInfo, ServerErrorType.PARAM_USER_EMAIL);
  }

  public static void validateUserName(String userName, UriInfo uriInfo) {

    if (userName == null || userName.length() < 1) {
      throw new ServerResponseException(uriInfo, ServerErrorType.PARAM_USER_NAME);
    }

    if (userName.length() > PicheeseConst.USER_NAME_LENGHT) {
      throw new ServerResponseException(uriInfo, ServerErrorType.PARAM_USER_NAME_LENGTH);
    }
  }
}
